#!/usr/bin/python
import sys
import os
import time
import shutil
import subprocess

try:
  #from ctypes import *
  if sys.platform == "win32":
    from ctypes.wintypes import DWORD, sizeof, byref, windll
    n = 0
    def EnumProcesses():
      #res = {}
      ProcessIds = (DWORD*256)()
      cb = sizeof(ProcessIds)
      BytesReturned = DWORD()
      #PROCESS_QUERY_INFORMATION = 0x0400
      windll.psapi.EnumProcesses(byref(ProcessIds), cb, byref(BytesReturned))
      nReturned = BytesReturned.value / sizeof(DWORD)
      pidProcess = [i for i in ProcessIds][:nReturned]
      return pidProcess
    def pid_exists(pid):
      return pid in EnumProcesses()
    while n < 30:
      try:
        if not pid_exists(int(sys.argv[1])):
          update_files = os.listdir("update")
          for update_file in update_files:
            if update_file == "conf.xml":
              shutil.copyfile("update/conf.xml", "conf/conf.xml")
            else:
              if update_file != "i_updater.py":
                shutil.copyfile("update/" + update_file, update_file)
            if update_file != "i_updater.py":
              os.remove("update/" + update_file)        
          time.sleep(10)
          subprocess.Popen([sys.executable, "siwim_i.py"], close_fds=True)
          break
        else:
          time.sleep(5)
          continue
      except Exception, ex:
        print str(ex)
        break
      n+=1
  elif sys.platform == "linux" or sys.platform == "linux2":
    update_files = os.listdir("update")
    for update_file in update_files:
      if update_file == "conf.xml":
        shutil.copyfile("update/conf.xml", "conf/conf.xml")
      else:
        if update_file != "i_updater.py":
          shutil.copyfile("update/" + update_file, update_file)
      if update_file != "i_updater.py":
        os.remove("update/" + update_file)
except Exception, ex:
  pass
   